Subject: usage of patented and closed source products in courses.

From: "Tzahi Fadida" <[email-masked]>
Date: Wed, 24 Dec 2003 17:44:18 +0200

Hi all,
I want to discuss an anti-academic issue i recently encountered.
the issue includes these problems which are not neccessarily mutually exclusive:
1) closed source applications in theoretic courses.
2) closed source applications in non theoretic courses.
3) patented technologies
4) patented scientific methodologies

1) closed source applications in theoretic courses are counter intuitive to its
definition. i.e. when you do your hw or experiment using that application you
cannot
prove that the experiment or hw has succeded or failed due to source bugs or
fallacy
of the underlying algorithms.
2) usage of that applications as a matter of fact is false when there are free
solutions that can be extended to academic usage on these courses. just using
them
do not add anything to the academic experience. you can just read a book or a
manual
on how to use them.
3) patented technologies means that whatever you learned in the course can only
be
used in the company that provided it or the company product that probably has to
be
bought to use it. i.e: there is no added benefit beside advertising a certain
product by the lecture or TA that probably work for this company. in addition
many
times you will hear: "I am on NDA so i can't comment on that" so why teach if
you
can only deliver partail information!
4) THESE ARE THE WORSE KINDS!: meaning you cannot reimplement the applications
or use the methodologies that implement or extend them. i.e.: its not beneficial
in the next 20 years or so depending on the patent and patent area, aside from
the company who patented them or the product that implement them or a license.
there are probably ways around this but why study the ways you cannot
use/reimplement yourselve or making a thesis that could be used outside the
scope of the patent.

ok, after all that, specifically i have a grievance with a course called "intro
to databases engineering" which its main theme is ECA - event condition action.
the lecturer and TA both work for IBM. the engine called AMIT is used to
identify world and database events and repond to situations, and used in hw and
exams. its a lot like the states model in UML but for events only. several
techniques are patented and are being studied at this class. The main excuse for
this product promotion is that the lecturer wants to teach us about new
technologies that are about to come out. now, if i wanted to do that, i could
open a gartner survey or a few companies brochurs.
This course is considered mandatory to MSC students and thus cannot a avoid it.

Summary: is the technion:
a) a software engineering school.
b) a college
c) a university for higher learning as was defined for centuries.

just my 2c.

* - * - *
Tzahi Fadida
MSc Student
Information System Engineering Area
Faculty of Industrial Engineering & Management
Technion - Israel Institute of Technology
Technion City, Haifa, Israel 32000
Email [email-masked]
Technion Email: [email-masked]
* - * - * - * - * - * - * - * - * - *

WARNING TO SPAMMERS:  see at http://members.lycos.co.uk/my2nis/spamwarning.html

---

From: Omer Zak <[email-masked]>
Date: Wed, 24 Dec 2003 17:58:43 +0200 (EET)

> 4) patented scientific methodologies

[... snipped ...]

> the lecturer and TA both work forIBM. the engine called AMIT is used to

The first question which I'd ask is whether the patented know-how is
fundamental for whatever subject you are studying.  For example, the RSA
algorithm was patented (until recently) but had fundamental importance.

Or (another hypothetical example) study of the applications of electron
microscopes or of lasers when their patents were in force.

The next question is whether studying the patented know-how is mandatory
for getting the M.Sc. by faculty's academic regulations.  But I can
suppose that sometimes new developments in fields of knowledge are
patented, yet have fundamental importance.

The third question is whether there is sufficient disclosure of
information in order to verify experimental results obtained by use of the
patented technology in question.  With electron microscopes and lasers
there were no such problems.  All important information about the physical
configuration of those instruments is available to the experimenter, and
they are much less complicated than the software to which Tzahi alluded.
This is important as part of the principle of peer review, by which
science self-checks and advances.

In brief:  Tzahi's grievance may be attacked on grounds of peer review.
If research based upon those secret technologies cannot be verified by
peer review, then it has no place in academic journals or in universities.
At best, it has place in industrial R&D centers.
                                             --- Omer
My opinions, as expressed in this E-mail message, are mine alone.
They do not represent the official policy of any organization with which
I may be affiliated in any way.
WARNING TO SPAMMERS:  at http://www.zak.co.il/spamwarning.html

---

From: Shlomi Fish <[email-masked]>
Date: Wed, 24 Dec 2003 18:32:41 +0200 (IST)

> of the underlying algorithms.

Possibly correct. However, if the software is well tested and mature, the
chance you'll run into a bug that's not your fault, is very small. During
my entire studies, I never ran into a bug in Windows, MSVC, or Matlab. (or
other programs that I used that we were instructed to use).

On the other hand, open source software that is installed on the
university's computers may have bugs, and these would be hard for the
under-educated student to analyze or even for the highly professional
student to trace with his limited means.

So, my position is that if an open source solution is good enough, use it.
Else, find a proprietary solution that is known to work extremely well.

> do not add anything to the academic experience. you can just read a book or a

But sometimes such applications can do what no open source solution can.
For example, I don't have problems with universities using Excel, because
it's an excellent program, and I don't think OOo's spreadsheet is there
yet.

> can only deliver partail information!

This is indeed sad, and should be avoided. A course should teach
real-life, practical knowledge, not such that is highly dependant on a
proprietary solution. As for the "I'm on NDA" - isn't the entire purpose
of patents is to make sure their owners can actively reveal everything
about them?

Of course, you shouldn't take it too far. Apple has issued a patent on the
equation a*X+(1-a)*Y (alpha opacity), which has tons of prior art and
likely this patent won't hold in court. But I believe you're not referring
to such extreme and silly cases.

> use/reimplement yourselve or making a thesis that could be used outside the

Well, like Omer Zak noted, it may not be so bad, depending on the context
of the application. Sometimes cutting-edge developments are patented, but
the knowledge that is required to use and implement the technology is
well-documented and reproducible. So you just have to pay royalties in
certain cases.

> This course is considered mandatory to MSC students and thus cannot a avoid it.

Well, this is a problem in the course's staff rather than issues #1-4. You
may well be advised to file a complaint about it to the department's dean.
(perhaps a collective one)

Regards,

	Shlomi Fish

----------------------------------------------------------------------
Shlomi Fish        [email-masked]
Home Page:         http://t2.technion.ac.il/~shlomif/

An apple a day will keep a doctor away. Two apples a day will keep two
doctors away.

	Falk Fish

---

From: "Tzahi Fadida" <[email-masked]>
Date: Wed, 24 Dec 2003 19:53:44 +0200

> -----Original Message-----
> From: Shlomi Fish [mailto:[email-masked]]
> Sent: Wednesday, December 24, 2003 6:33 PM
> To: [email-masked]
> Subject: Re: [hackers-il] usage of patented and closed source
> products in courses.
>
>

well, we are not studying word. however, I do teach access in my TA sessions,
and i can tell you that the same version of access will not neccessarily work or
behave the same on different machines with different configurations with vague,
and sometimes difficult to resolve reasons.
as for matlab, i did work with it for a short while and i encountered
differences that were somtimes stated from the company and sometimes were not
but not neccessarily a bug. also, in performance dependant applications like
matlab, if you don;t know the underlying algorithm it is sometimes hard to
design an experiment and know when it will finish or how it will behave on
different points like zeroing variables under certain conditions, etc...

> Else, find a proprietary solution that is known to work extremely well.

i must contest. this is not an engineering school, we are in the academia.
aside: "I myself don't believe that we should study programming languages to
know the language but understand
its concepts contrary to current several courses methodologies".
so, if there is a bug in an open source program, bring it to the TA knowledge an
he may help fix it, so the next
course will not suffer this bug. i.e. most courses have an acceptable curve of
problems, but here it can be fixed after a semester or two, while in the closed
source world you probably can forget it and just dump the program if you can't
circumvent it.

> it's an excellent program, and I don't think OOo's spreadsheet is there

on the other hand, excel algorithms are not known to u. so if i were, and i did
:), to run a simulation to find a parameter in a statistical experiment in a
cognitive course, i cannot estimate the time it would finish besides trial and
error. If i just ran it, it would have taken me a week instead of 6 hrs.

> to such extreme and silly cases.

yeah, i agree.

> well-documented and reproducible. So you just have to pay royalties in

yeah, but we are not here to promote a product. I think a university should
stick to scientific principles that you could
later decide wether you are going to pay royalties to a company which patented a
certain methodology.

> (perhaps a collective one)

i will think about it, after the course is finished.
and as for collective, this is the IE department not CS. no one here gives a
rats ass about open source, except
a small minority, somoe of them a member of this list and linux-il.

> To unsubscribe from this group, send an email to:
> [email-masked]
>
>
>
> Yahoo! Groups Links
>
> To visit your group on the web, go to:
>  http://groups.yahoo.com/group/hackers-il/
>
> To unsubscribe from this group, send an email to:
>  [email-masked]
>
> Your use of Yahoo! Groups is subject to:
>  http://docs.yahoo.com/info/terms/
>
>
>

---

From: Oleg Goldshmidt <[email-masked]>
Date: 24 Dec 2003 20:44:43 +0200

> definition. i.e. when you do your hw or experiment using that
> application you cannot prove that the experiment or hw has succeded
> or failed due to source bugs or fallacy of the underlying
> algorithms.

Well, it looks like you are assuming that there is a viable open
source alternative [see also item 2 below]. What if there isn't? 

As to your "bugs" argument, if the app in question has a solid
reputation I would suggest keeping looking for bugs in your code. I
don't know what examples you have in mind, I am thinking of MatLab, 
Mathematica, etc. MatLab has open source alternatives (SciLab, Octave)
that lag behind in functionality, but you can verify a large number of
things with them. It will still make sense to use MatLab in
instruction.

I recall a case from my own teaching practice where Excel gave wrong
results. This was verified by doing the calculations by hand - this is
always a very good learning experience.

> solutions that can be extended to academic usage on these courses.

This is where you are making the assumption mentioned above [see item 1]
explicitly.

> just using them do not add anything to the academic
> experience. you can just read a book or a manual on how to use them.

It adds to your skill set and experience, which is more than you can
get from just reading the frigging manual. It may prove useful during
subsequent studies. It may be a tool widely used in the industry in
which you are likely to work upon graduation.

> be used in the company that provided it or the company product that
> probably has to be bought to use it.

Here I disagree. Whatever is patented is, by definition, open. If you
have to pay royalties to apply it in real life is irrelevant. As a
student, you can benefit from studying the technology in question.

> 4) THESE ARE THE WORSE KINDS!: 

The worst kind include patents on scientific methodologies that have
been known for a long long time. This patent

http://www1.cs.columbia.edu/~traub/html/body_patent_information.html

(awarded in 1999) is on a well-known mathematical technique that has
been developed, IIRC, in the sixties if not earlier, applied in a
particular area. The patent-holders' claim to fame, it seems, is that
they "discovered" that it could be faster than other methods for
certain problems. The speed of solving this particular kind of
*mathematical* problem was the primary motivation for development of
the method (in the 60-ies, as I said) in the first place. Check,
e.g. "Numerical Recipes" for introduction. I find the patent ridiculous.

What would you say if your courses included low discrepancy sequences?
By Prof. Traub? ;-)

> ok, after all that, specifically i have a grievance with a course
> called "intro to databases engineering" which its main theme is ECA
> - event condition action.  the lecturer and TA both work for
> IBM. the engine called AMIT is used to identify world and database
> events and repond to situations, and used in hw and exams.

OK, I work for IBM, I have no specific knowledge of AMIT, and I cannot
comment on the specifics for both these reasons. ;-)

In general, suppose your instructors think that their students would
benefit from learning rule-based reasoning techniques in AI[1]. They give
you some background, and now they want to give you a demonstration of
a relatively sophisticated engine that they know well (I'd say it is a
necessary condition). Suppose the thing is also programmable to some
extent and allows the students to try things, feed data to it, create
and modify rules, and thus do exercises. 

If you happen to know that there exists an open source tool that is no
worse that the proprietary one offered to you by the instructors, why
can't you ask politely if they know about it? Explain why having the
source and the ability to tweak the algorithms inside is beneficial.

I can tell you what my reaction to this would be. I would suggest that
you use both tools in parallel and compare the results. If the results
are the same consistently, then you would gain the skills and
knowledge of an open source tool that performs - for the set of
problems studied - at par with the allegedly advanced proprietary
tool. That's useful. If the results are different, could you figure
out what the difference is? Could you modify the open source code to
get a closer match? Could you reason which is correct? Could you
improve upon the open source program based on what you've learned?[2]

In the Excel example mentioned above the suggestion to use Excel
(rather than doing the stuff by hand) invariably came from
students. The suggestion to do the stuff both by hand and with Excel
invariably came from me (the instructor). The results were invariably
different. The students learned.

Question is, did you approach your lecturer? What did he (or she) say?

> The main excuse for this product promotion is that the lecturer
> wants to teach us about new technologies that are about to come
> out. now, if i wanted to do that, i could open a gartner survey or a
> few companies brochurs.

You cannot explore the technology or learn to use it by reading
Gartner reports. I keep returning to the MatLab example.

To summarize: I don't think you can just reject usage of proprietary
technologies in instruction simply because they are not open-source.
If there is an open-source alternative you will, I think, benefit from
comparison. It may turn out that your lecturers will agree with this
last statement.

[1] OK, I probably goofed, most likely I mixed AMIT, 
    http://www.haifa.il.ibm.com/projects/software/amit/index.html
    and ARAD (can't find a description, but it's mentioned in the
    URL abive). I don't know if AMIT uses any rule-based AI, but it
    well may be the case. I told you I didn't know...

[2] This again assumes there is an open source alternative, of course.
    I would love to know if there is an open source AMIT - can you
    give me a pointer?

-- 
Oleg Goldshmidt | [email-masked]

---

From: Shlomi Fish <[email-masked]>
Date: Mon, 26 Jan 2004 17:25:12 +0200 (IST)

> a small minority, somoe of them a member of this list and linux-il.

I disagree. If all students suffered abuse from the course stuff due to
the proprietary, secretive and experimental nature of the software that
was chosen, then they can all care enough to file a complaint together. It
has nothing to do with open source, and everything to do with proper
academics.

So, you should get your act together and file a collective complaint.

Regards,

	Shlomi Fish

You are banished! You are banished! You are banished!

Hey? I'm just kidding!

---

From: "Tzahi Fadida" <[email-masked]>
Date: Tue, 27 Jan 2004 20:29:21 +0200

> Sent: Monday, January 26, 2004 5:25 PM
> Subject: Collective Appeal [was RE: [hackers-il] usage of patented
> and closed source products in courses.]
>
>

I disagree to the disagree, you don't rattle the boat you are in, or you
might sink. Doing an msc is different from doing bsc where different
laws of physics apply. I talked to the lecturer and told him how i felt.
for now, this is all i can do. I also talked to others about related issues
and code of conduct in the academics.
In the end, after asking around i felt that most don't care about it so i am
dropping the issue for now.
I think the problem is a code of conduct that is essentially non-existent.